# powerup classes

from std import *
from constants import *
from entity import Ent
from player import Player

class Powerup(Ent):
    def __init__(self):
        Ent.__init__(self)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return

        self.killflag=1

#----------------------------------------------

class SmallRepairItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('small_repair.chr')
        self.leftanim=['Z0']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        Log('whap')

        e.HealHP(10)

#----------------------------------------------

class LargeRepairItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('large_repair.chr')
        self.leftanim=['Z0W10 Z1W10 Z2W10 Z1W10 B']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.HealHP(25)

#- <Ear> --------------------------------------

class SmallRechargeItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('small_battery.chr')
        self.leftanim=['Z0']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.RestoreEP(10)

#- <Ear> --------------------------------------

class LargeRechargeItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('large_battery.chr')
        self.leftanim=['Z0W10 Z1W10 Z2W10 Z1W10 B']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.RestoreEP(25)

#- <Ear> --------------------------------------

class ArmourModuleItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('armour_module.chr')
        self.leftanim=['Z0']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.IncreaseHP(10)

#- <Ear> --------------------------------------

class EnergyModuleItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('energy_module.chr')
        self.leftanim=['Z0']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.IncreaseEP(5)

#- <Ear> --------------------------------------

class LifeItem(Powerup):
    def __init__(self,x=0,y=0):
        Powerup.__init__(self)
        self.x=x
        self.y=y
        self.CreateCHR('life.chr')
        self.leftanim=['Z0']
        self.rightanim=self.leftanim
        self.SetState(state.STAND)

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return
        self.killflag=1

        e.GainLife()